package jpa.test.annotation.discriminatorvalue;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import jpa.test.client.ClientJPABase;
import jpa.test.annotation.discriminatorvalue.entity.BaseEntityCalss;
import jpa.test.annotation.discriminatorvalue.entity1.SubEntityClass;

public class Client extends ClientJPABase
{
    public Client() {}

    public void testMethod004()
    {
        EntityManagerFactory emf = null;
        EntityManager em = null;

        testStart("DiscriminatorColumn-Test004");
        try
        {
            setPersistenceUnitName("TestPersistenceUnit");

            em = getEntityManager();

            BaseEntityCalss entity0 = new BaseEntityCalss();
            jpa.test.annotation.discriminatorvalue.entity1.SubEntityClass entity1 = new jpa.test.annotation.discriminatorvalue.entity1.SubEntityClass();
            jpa.test.annotation.discriminatorvalue.entity2.SubEntityClass entity2 = new jpa.test.annotation.discriminatorvalue.entity2.SubEntityClass();

            entity0.id = "ID004-000";
            entity0.superClassData = "InsertBaseClassData-004-000";
            entity1.id = "ID004-001";
            entity1.superClassData = "InsertBaseClassData-004-001";
            entity1.subClassData = "InsertSubClassData-004-001";
            entity2.id = "ID004-002";
            entity2.superClassData = "InsertBaseClassData-004-002";
            entity2.subClassData = "InsertSubClassData-004-002";

            em.persist(entity0);
            em.persist(entity1);
            em.persist(entity2);

            transactionBegin();
            em.flush();
            transactionCommit();

            // When keep using the same EM, PC returns the data that holding.
            // To confirm the state of the table on DB, once delete PC.
            // When keep using the same PC, it avoids the problem that caused internal wrong.
            cleanup();

            em = getEntityManager();

            jpa.test.annotation.discriminatorvalue.entity1.SubEntityClass entity3 = 
                em.find(jpa.test.annotation.discriminatorvalue.entity1.SubEntityClass.class, "ID004-001");
            jpa.test.annotation.discriminatorvalue.entity2.SubEntityClass entity4 = 
                em.find(jpa.test.annotation.discriminatorvalue.entity2.SubEntityClass.class, "ID004-002");
            BaseEntityCalss entity5 = em.find(BaseEntityCalss.class, "ID004-000");

            log("=======================================================================");
            log("data check");
            assertEquals("InsertBaseClassData-004-001", entity3.superClassData);
            assertEquals("InsertSubClassData-004-001", entity3.subClassData);
            assertEquals("InsertBaseClassData-004-002", entity4.superClassData);
            assertEquals("InsertSubClassData-004-002", entity4.subClassData);
            assertEquals("InsertBaseClassData-004-000", entity5.superClassData);

            log("=======================================================================");
            log("check value of DiscriminatorValue");
            assertEquals("SubEntityClass1", entity3.dataType);
            assertEquals("SubEntityClass2", entity4.dataType);
            assertEquals("SuperClass", entity5.dataType);

        }
        catch(Throwable thw)
        {
            failed("unexpected error occurred",thw);
            thw.printStackTrace();
        }
        finally
        {
            testEnd();
            cleanup();
        }
    }


    public static void main(String[] args)
    {
        Client client = new Client();
        client.testMethod004();
    }

}
